﻿selectedToonDelete = ""
LWOptionsGeneral =
{
  type = 'group',
  name = "Liquid-Wealth: General Settings",
  cmdInline = false,
  args =
  {
    generalheaderDes =
    {
      order = 1,
      type = "description",
      name = "Please change your setting below",
      cmdHidden = true,
    },
    headerDisplay =
    {
      order = 2,
      type = "header",
      name = "Tooltip Display Options",
      cmdHidden = true,
    },
    simplePlayerBags =
    {
      type = 'toggle',
      name = "Simple Details (Player Bags |TInterface\\Icons\\INV_Misc_Bag_08:25|t)",
      desc = "Enable this to display a simpler view of the Players Bags.",
      order = 3,
      width = "full",
      get = function() return Liquid_Wealth.db.profile.noBagInfoTip end,
      set = function(_, v) Liquid_Wealth.db.profile.noBagInfoTip = v end,
    },
    simplePlayerBank =
    {
      type = 'toggle',
      name = "Simple Details (Player Bank |TInterface\\Icons\\INV_Misc_Bag_08:25|t)",
      desc = "Enable this to display a simpler view of the Players Bank.",
      order = 4,
      width = "full",
      get = function() return Liquid_Wealth.db.profile.noBankInfoTip end,
      set = function(_, v) Liquid_Wealth.db.profile.noBankInfoTip = v end,
    },
    showHintTip =
    {
      type = 'toggle',
      name = "Enable Hint Tips",
      desc = "Enable this to display a a tooltip below, to show common tasks or functions.",
      order = 5,
      width = "full",
      get = function() return Liquid_Wealth.db.profile.displayHints end,
      set = function(_, v) Liquid_Wealth.db.profile.displayHints = v end,
    },
    headerPriceOptions =
    {
      order = 6,
      type = "header",
      name = "Vender & Auction Addon Settings",
      cmdHidden = true,
    },
    auctionselect =
    {
      order = 7,
      type = "select",
      name = "Auction Addon List",
      desc = "Select Auction Pricing Addon.",
      disabled = function()
        _, noindex = Liquid_Wealth:listLoadedAuctions()
        return noindex
      end,
      get = function() return Liquid_Wealth.db.profile.selectedAuctionAddon end,
      set = function(_, v) Liquid_Wealth.db.profile.selectedAuctionAddon = v end,
      values = function() return Liquid_Wealth:listLoadedAuctions() end,
    },
    headerScanningOptions =
    {
      order = 8,
      type = "header",
      name = "Scanning Options",
      cmdHidden = true,
    },
    EnableGuildBankScanning =
    {
      type = 'toggle',
      name = "Enable Guild Bank Scanning",
      desc = "Enable this to scan the guild bank.",
      order = 9,
      width = "full",
      get = function() return Liquid_Wealth.db.profile.scanGuildBank end,
      set = function(_, v) Liquid_Wealth.db.profile.scanGuildBank = v end,
    },
    generalheader2 =
    {
      order = 10,
      type = "header",
      name = "Force Scanning Options",
      cmdHidden = true,
    },
    forceLocalScan =
    {
      type = "execute",
      name = "Player Bags Scan",
      order = 11,
      desc = "This command will force a scan of the players bags.",
      func = function() Liquid_Wealth:forceScan(1) end,
    },
	HeaderDebug =
    {
      order = 12,
      type = "header",
      name = "Debug Options",
      cmdHidden = true,
    },
	tooltipDebug =
    {
      type = 'toggle',
      name = "Enable Tooltip Debugging",
      desc = "Enable this to show Tooltip Debugging.",
      order = 13,
      width = "full",
      get = function() return Liquid_Wealth.db.profile.toolTipDebugEnabled end,
      set = function(_, v) Liquid_Wealth.db.profile.toolTipDebugEnabled = v end,
    },
  },
}

LWOptionsSkins = {
  name = "Liquid-Wealth: ToolTip Skinning",
  type = 'group',
  desc = "Options for Skinning The ToolTip",
  args =
  {
    generalheader =
    {
      order = 1,
      type = "header",
      name = "ToolTip Skinning Settings",
      cmdHidden = true,
    },
    TicTacSkinning =
    {
      type = 'toggle',
      name = "Enable TicTac Skinning",
      desc = "Enables the skinning of the tooltip using TicTac for Skinning. Note: If you want to clear the skin you have to disable this, and then Reload UI",
      order = 2,
      disabled = function() return not (_G.TipTac and _G.TipTac.AddModifiedTip) end,
      get = function() return Liquid_Wealth.db.profile.TipTacSkin end,
      set = function(_, v) Liquid_Wealth.db.profile.TipTacSkin = v end,
    },
  },
}

LWOptionsDatabase = {
  name = "Liquid-Wealth: Database",
  type = 'group',
  desc = "Settings to allow addon debugging",
  args =
  {
    generalheader =
    {
      order = 1,
      type = "header",
      name = "Database Settings",
      cmdHidden = true,
    },
    lwConfigVerbs =
    {
      order = 2,
      type = "description",
      name = "Liquid-Wealth Version: " .. GetAddOnMetadata("Liquid_Wealth", "Version") .. "\nLiquid-Wealth (Final) Database Version: " .. currentDBVersion .. "\nLiquid-Wealth Database Version: ",
      fontSize = "medium",
      cmdHidden = true,
    },
    resetDatabases =
    {
      type = 'execute',
      name = "Reset All Data",
      desc = "This will clear all databases with in Liquid-Wealth. Use this if you are having database problems, or if you have old databases.",
      order = 3,
      func = function()
        Liquid_Wealth:resetMasterDatabases()
      end,
    },
    removeCharFromDB =
    {
      order = 4,
      type = "select",
      name = "Reset Selected Toon Data",
      desc = "Select Toon To Remove From Database.",
      set = function(_, v)
        local tableList = {}
        for i, _ in pairs(Liquid_Wealth.db.realm.toon) do
          table.insert(tableList, i)
        end
        Liquid_Wealth:removeToonFromDB(tableList[v])
      end,
      values = function()
        local tableList = {}
        for i, _ in pairs(Liquid_Wealth.db.realm.toon) do
          local toonWIcon = Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[i].unitID) .. " " .. "|c" .. Liquid_Wealth:ClassColor(Liquid_Wealth.db.realm.toon[i].unitID) .. i .. "|r"
          table.insert(tableList, toonWIcon)
        end
        return tableList
      end,
    },
    removeGuildFromDB =
    {
      order = 5,
      type = "select",
      name = "Reset Selected Guild Data",
      desc = "Select Guild To Remove From Database.",
      set = function(_, v)
        if tablelength(Liquid_Wealth.db.realm.guild) > 0 then
          local tableList = {}
          for i, _ in pairs(Liquid_Wealth.db.realm.guild) do
            table.insert(tableList, i)
          end
          Liquid_Wealth:removeGuildFromDB(tableList[v])
        end
      end,
      values = function()
        local tableList = {}
        if tablelength(Liquid_Wealth.db.realm.guild) > 0 then
          for i, _ in pairs(Liquid_Wealth.db.realm.guild) do
            table.insert(tableList, i)
          end
        else
          table.insert(tableList, "No Guild Data")
        end
        return tableList
      end,
    },
  },
}

CommandLineOptionsRTC = {
  name = "Remote Toon Config",
  type = "group",
  args = {
    confdesc = {
      order = 1,
      type = "description",
      name = "Please change your setting below",
      cmdHidden = true,
    },
    generalheader = {
      order = 2,
      type = "header",
      name = "Vender & Auction Addon Settings",
    },
    nulloption = {
      order = 3,
      type = "description",
      name = " ",
      cmdHidden = true,
    },
    RanTest = {
      type = "execute",
      name = "Ran Test",
      order = 9,
      desc = "Ran Text.",
      func = function()
        serializedData = Liquid_Wealth:Serialize("NPS")
        Liquid_Wealth:SendCommMessage("LMAC", serializedData, "WHISPER", "wildorebar")
      end,
    },
  }
}

LWOptionsFilter = {
	name = "Liquid-Wealth: Filters",
	type = 'group',
	desc = "Settings for Filters Module",
	args =
	{
		generalheader =
		{
			order = 1,
			type = "header",
			name = "Filter Settings",
			cmdHidden = true,
		},
		addNewFilter =
		{
		  type = "execute",
		  name = "Set Filter Table",
		  order = 2,
		  desc = "Set Filter Table",
		  func = function() Liquid_Wealth:DBFilterTest() end,
		},
	}
}

function Liquid_Wealth:DBFilterTest()
	Liquid_Wealth.db.realm.filters = {};
	
	Liquid_Wealth:NewFilter("Cloth","Tradeskill.Mat.ByType.Cloth","PTSet",53010)
	Liquid_Wealth:NewFilter("Gems","Tradeskill.Mat.ByType.Gem","PTSet",71807)
	Liquid_Wealth:NewFilter("Herbs","Tradeskill.Mat.ByType.Herb","PTSet",52986)
	Liquid_Wealth:NewFilter("Enchanting","Tradeskill.Crafted.Enchanting","PTSet",74250)
	
end

function Liquid_Wealth:listLoadedAuctions()
  local table = {}
  local noIndex = true
  table["--None--"] = "--None--"
  for _, addon in pairs(Liquid_Wealth.AuctioneerAddons) do
    local _, isloaded = IsAddOnLoaded(addon.name);
    if (isloaded) then --Check To See If Addon InList Is Enabled
      table[addon.name] = addon.name
      noIndex = false
    end
  end
  return table, noIndex
end

function Liquid_Wealth:LoadOptionsTables()
  local AceConfig = LibStub("AceConfig-3.0")
  AceConfig:RegisterOptionsTable("LiquidWealth", LWOptionsGeneral, { "lw", "liquidwealth" })
  LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("LiquidWealth Skin", LWOptionsSkins)
  LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("LiquidWealth Database", LWOptionsDatabase)
  LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("LiquidWealth Filters", LWOptionsFilter)

  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("LiquidWealth", "LiquidWealth")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("LiquidWealth Skin", "ToolTip Skinning", "LiquidWealth")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("LiquidWealth Database", "Database", "LiquidWealth")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("LiquidWealth Filters", "Filters", "LiquidWealth")
  LibStub("LibAboutPanel").new("LiquidWealth", "Liquid_Wealth")
end