﻿PT = LibStub("LibPeriodicTable-3.1")
table_filters = {
	["Cloth"] = {
		["ptsetings"] = {
			["setname"] = "Tradeskill.Mat.ByType.Cloth",
		}, -- [1]
		["vender"]=0,
		["auction"]=0,
		["icon"]="53010",
	},
	["Gems"] = {
		["ptsetings"] = {
			["setname"] = "Tradeskill.Mat.ByType.Gem",
		}, -- [1]
		["vender"]=0,
		["auction"]=0,
		["icon"]="71807",
	},
	["Herbs"] = {
		["ptsetings"] = {
			["setname"] = "Tradeskill.Mat.ByType.Herb",
		}, -- [1]
		["vender"]=0,
		["auction"]=0,
		["icon"]="52986",
	},
	["Enchanting"] = {
		["ptsetings"] = {
			["setname"] = "Tradeskill.Crafted.Enchanting",
		}, -- [1]
		["vender"]=0,
		["auction"]=0,
		["icon"]="74250",
	}
}

function Liquid_Wealth:NewFilter(Name,PTSetName,FilterType,Icon)
	if not Liquid_Wealth.db.realm.filters then
		Liquid_Wealth.db.realm.filters = {};
	end
	if not Liquid_Wealth.db.realm.filters[Name] then
		Liquid_Wealth.db.realm.filters[Name]={};
	end
	if not Liquid_Wealth.db.realm.filters[Name].ptsetings then
		Liquid_Wealth.db.realm.filters[Name].ptsetings={};
	end
	local currentIndex = table.getn(Liquid_Wealth.db.realm.filters[Name].ptsetings);
	print("Current Index: "..currentIndex)
	currentIndex=currentIndex+1;
	print("Index Updated: "..currentIndex)
	if not Liquid_Wealth.db.realm.filters[Name].ptsetings[currentIndex] then
		Liquid_Wealth.db.realm.filters[Name].ptsetings[currentIndex]={}
	end
	Liquid_Wealth.db.realm.filters[Name].ptsetings[currentIndex].setname=PTSetName
	Liquid_Wealth.db.realm.filters[Name].ptsetings[currentIndex].type=FilterType
	Liquid_Wealth.db.realm.filters[Name].vender=0
	Liquid_Wealth.db.realm.filters[Name].auction=0
	Liquid_Wealth.db.realm.filters[Name].icon=Icon
end

function Liquid_Wealth:showFilterToolTip()
    modeHeader = tip:AddLine("")
	local LWWhite18FontFont = CreateFont("LWWhite18FontFont")
	LWWhite18FontFont:SetFont(GameTooltipText:GetFont(), 18)
	LWWhite18FontFont:SetTextColor(255,255,255)
    tip:SetCell(modeHeader, 1, "Filters", LWWhite18FontFont, "CENTER", 5)
	tip:AddLine("")
	tip:AddSeparator(2)
	tip:AddLine("")
	modeHeader = tip:AddLine("")
	tip:SetCell(modeHeader, 2, "[Name]", nil, "CENTER")
	tip:SetCell(modeHeader, 4, "[Vender]", nil, "CENTER")
	tip:SetCell(modeHeader, 5, "[Auctions]", nil, "CENTER")
	
	if Liquid_Wealth.db.realm.filters==nil then
		modeHeader = tip:AddLine("")
		local LWYellow18FontFont = CreateFont("LWYellow18FontFont")
		LWYellow18FontFont:SetFont(GameTooltipText:GetFont(), 18)
		LWYellow18FontFont:SetTextColor(252,194,0)
		tip:SetCell(modeHeader, 1, "Please GoTo Addon Options, and Setup Filters", LWYellow18FontFont, "CENTER",5)
	else
		for filter in pairs(Liquid_Wealth.db.realm.filters) do
			modeHeader = tip:AddLine("")
			_, _, _, _, _, _, _, _,_, ItemTexturePath, _ = GetItemInfo(Liquid_Wealth.db.realm.filters[filter].icon)
			tip:SetCell(modeHeader, 1, "|T" .. ItemTexturePath .. ":25|t", nil, "CENTER")
			local LWYellow18FontFont = CreateFont("LWYellow18FontFont")
			LWYellow18FontFont:SetFont(GameTooltipText:GetFont(), 18)
			LWYellow18FontFont:SetTextColor(252,194,0)
			tip:SetCell(modeHeader, 2, filter, LWYellow18FontFont, "CENTER")
			if filter == "Enchanting" then
				tip:SetCell(modeHeader, 4, "N/A", LWWhite18FontFont, "CENTER", 1)
			else
				tip:SetCell(modeHeader, 4, Liquid_Wealth:copperToText(Liquid_Wealth.db.realm.filters[filter].vender), LWWhite18FontFont, "CENTER", 1)
			end
			
			tip:SetCell(modeHeader, 5, Liquid_Wealth:copperToText(Liquid_Wealth.db.realm.filters[filter].auction), LWWhite18FontFont, "CENTER", 1)
		end
	end
end

function Liquid_Wealth:ScanPT()
	for bagId = -1, 11 do -- Add up the value of each bag's contents
		local bagSlots = GetContainerNumSlots(bagId);
		if (bagSlots > 0) then
			for slot = 1, bagSlots do
				local slotTotalAuction = 0
				local slotTotalVender = 0
				for filter in pairs(Liquid_Wealth.db.realm.filters) do
					local itemLink = GetContainerItemLink(bagId, slot);
					if (itemLink) and PT:ItemInSet(itemLink, Liquid_Wealth.db.realm.filters[filter].ptsetings[1].setname)then
						local _, itemCount = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
						if not Liquid_Wealth:IsItemSoulbound(bagId, slot) then
							itemsPriceAuction = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
						end
						local _, _, _, _, _, _, _, _,_, _, itemsPriceVender=GetItemInfo(itemLink)
						if (itemsPriceAuction) or (itemsPriceVender) then
							PriceTotal = 0
							PriceTotal = itemCount * itemsPriceAuction;
							slotTotalAuction = slotTotalAuction + floor(PriceTotal);
							Liquid_Wealth.db.realm.filters[filter].auction=Liquid_Wealth.db.realm.filters[filter].auction + slotTotalAuction
							PriceTotal = 0
							PriceTotal = itemCount * itemsPriceVender;
							slotTotalVender = slotTotalVender + floor(PriceTotal);
							Liquid_Wealth.db.realm.filters[filter].vender=Liquid_Wealth.db.realm.filters[filter].vender + slotTotalVender
						end
					end
				end
			end
		end
	end
end


function Liquid_Wealth:ScanFilters(bagId)
	for filter in pairs(Liquid_Wealth.db.realm.filters) do
		local bagTotal = 0;
		local bagFilterTotal = 0;
		if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
			local bagSlots = GetContainerNumSlots(bagId);
			if (bagSlots > 0) then
				for slot = 1, bagSlots do
					for ptsetings_Name in pairs(Liquid_Wealth.db.realm.filters[filter].ptsetings)do
						local PriceTotal = 0;
						local itemsPrice = 0;
						local itemLink = GetContainerItemLink(bagId, slot);
						if (itemLink) and PT:ItemInSet(itemLink, Liquid_Wealth.db.realm.filters[filter].ptsetings[1].setname)then
							local _, itemCount = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
							if not Liquid_Wealth:IsItemSoulbound(bagId, slot) then
								itemsPrice = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
							end
							if (itemsPrice) then
								PriceTotal = itemCount * itemsPrice;
								bagTotal = bagTotal + floor(PriceTotal);
							end
						end
					end
				end
			end
		end
		
		print(Liquid_Wealth.db.realm.filters[filter].ptsetings[1].setname)
	
	end
end