﻿Liquid_Wealth = LibStub("AceAddon-3.0"):NewAddon("Liquid-Wealth", "AceEvent-3.0", "AceComm-3.0", "AceConsole-3.0", "AceSerializer-3.0"); --Declare Ace3 Addon
local LibQTip = LibStub("LibQTip-1.0") --Declare ToolTip Plugin
local ldb_obj = LibStub("LibDataBroker-1.1"):NewDataObject("Liquid_Wealth", { icon = "Interface\\Icons\\INV_Misc_Coin_02.png", label = "Liquid-Wealth", type = "data source", text = "Liquid-Wealth" }); --Declare LibDataBroker Plugin
local abacus = LibStub("LibAbacus-3.0"); --Used To Display Money

--local tipdebug = true;

function Liquid_Wealth:OnInitialize()
  Liquid_Wealth.db = LibStub("AceDB-3.0"):New("Liquid_WealthDB", DATABASE_DEFAULTS, 'Default')
  --Set the current login toon as the currently selected toon. This will tell the tooltip to display the current toon's information.
  varCurrentPlayer = UnitName("player");
  --Call clsdatabase this checks the databased version, and to see if there is data in the database
  Liquid_Wealth:CheckMasterDatabase();
  --Calls ClsDatabase, checks to see if the current toon is in the database, and checks guild information
  Liquid_Wealth:CheckToonEntery(UnitName("player"), "local", Liquid_Wealth:genHexPSK(), UnitSex("Player"), UnitRace("Player"), UnitClass("Player"));
end


function Liquid_Wealth:OnEnable()
	self:Print("Liquid_Wealth Now Running");
	varIsBankFrameOpen = false;
	tabsNotScanned = {}
	--Load Options Table from clsAce3ConfigCore
	Liquid_Wealth:LoadOptionsTables()
	self:RegisterEvent("BANKFRAME_OPENED");
	self:RegisterEvent("BANKFRAME_CLOSED");
	self:RegisterEvent("PLAYER_GUILD_UPDATE");
	self:RegisterComm("LMAC")
	self:RegisterEvent("GUILDBANKFRAME_OPENED")
	self:RegisterEvent("GUILDBANKBAGSLOTS_CHANGED")

	Liquid_Wealth:CheckToonEntery(UnitName("player"), "local", Liquid_Wealth:genHexPSK(), UnitSex("Player"), UnitRace("Player"), UnitClass("Player"));
	if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
		ldbTitleCompatibility("Guild Bank")
	elseif(Liquid_Wealth.db.profile.displayMode == "PTFilter") then
		ldbTitleCompatibility("Custom Filter")
	else
		ldbTitleCompatibility("Player")
	end
end

function ldbTitleCompatibility(ldbTitleText)
  if IsAddOnLoaded("Titan") then
    ldb_obj.text = ldbTitleText
  else
    ldb_obj.text = "|CFFFFAA00Liquid-Wealth: |r".. ldbTitleText
  end
end

ITEM_BIND_ON_EQUIP = "Binds when equipped"; -- Item will be bound when equipped
ITEM_BIND_ON_PICKUP = "Binds when picked up"; -- Item wil be bound when picked up
ITEM_BIND_ON_USE = "Binds when used"; -- Item will be bound when used
ITEM_BIND_QUEST = "Quest Item"; -- Item is a quest item (same logic as ON_PICKUP)
ITEM_SOULBOUND = "Soulbound"; -- Item is Soulbound

--Calls LibGratuity to make tooltip and then scan though the lines to match based on item Rarity / Type / Soulbound
function Liquid_Wealth:IsItemSoulbound(bagId, slot)
  local tooltip = LibStub:GetLibrary("LibGratuity-3.0")
  local ContainerItemLink = GetContainerItemLink(bagId, slot)
  if ContainerItemLink then
    local _, _, iRarity, _, _, sType, sSubType, _, sEquipLoc = GetItemInfo(ContainerItemLink)
    tooltip:SetBagItem(bagId, slot)
    if tooltip:Find(ITEM_SOULBOUND, 1, 3) then
      return true
    else
      return false
    end
  end
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end


function Liquid_Wealth:IsItemQuest(bagId, slot)
  local tooltip = LibStub:GetLibrary("LibGratuity-3.0")
  local ContainerItemLink = GetContainerItemLink(bagId, slot)
  if ContainerItemLink then
    local _, _, iRarity, _, _, sType, sSubType, _, sEquipLoc = GetItemInfo(ContainerItemLink)
    tooltip:SetBagItem(bagId, slot)
    if tooltip:Find(ITEM_BIND_QUEST, 1, 3) then
      return true
    else
      return false
    end
  end
end

function Liquid_Wealth:PLAYER_GUILD_UPDATE()
	if IsInGuild() then
	  Liquid_Wealth:CheckToonEntery(UnitName("player"), "local", Liquid_Wealth:genHexPSK(), UnitSex("Player"), UnitRace("Player"), UnitClass("Player"));
	  local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
		if not Liquid_Wealth:CheckGuildBank(guildName) and guildName == not nil then
		  Liquid_Wealth.db.realm.guild[guildName] = {}
	  end
	end
end

function Liquid_Wealth:GUILDBANKFRAME_CLOSED()
  if (Liquid_Wealth.db.profile.scanGuildBank) then
    if next(tabsNotScanned) then
      -- Tabs never opened cannot be scanned. And no, force looping SetGuildCurrentGuildBankTab() doesn't work either, you really do have to wait until it populates (server roundtrip). This obviously can't be done on the bank closing.
      self:Print("Guild bank tabs not scanned: " .. table.concat(tabsNotScanned, ", "))
      tabsNotScanned = {}
    end
  end
  self.atGuildBank = nil
end

function Liquid_Wealth:GUILDBANKBAGSLOTS_CHANGED()
  if (Liquid_Wealth.db.profile.scanGuildBank) then
      if self.atGuildBank then
        Liquid_Wealth:ScanGuildBank()
      end
  end
end

function Liquid_Wealth:GUILDBANKFRAME_OPENED()
  self.atGuildBank = true
  if (Liquid_Wealth.db.profile.scanGuildBank) then
    local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
    if not Liquid_Wealth:CheckGuildBank(guildName) then
      Liquid_Wealth.db.realm.guild[guildName] = {}
      Liquid_Wealth:ScanGuildBank()
    else
      Liquid_Wealth:ScanGuildBank()
    end
  end
end

function Liquid_Wealth:PLAYER_ENTERING_WORLD()
  self:RegisterEvent("BAG_UPDATE"); --Fires many times (once for each slot in each container) during the login / UI load process. An addon which does extensive processing for this event should register it only after PLAYER_ENTERING_WORLD has fired if they are not interested in processing each event individually during the load process.
  if not InCombatLockdown() then
    Liquid_Wealth:Scan(0, 4);
  end
end

function Liquid_Wealth:BAG_UPDATE(event, bagID)
  if not InCombatLockdown() then
    if (bagID > -1 and bagID < 5) then --Update Only The Local Bags
      Liquid_Wealth:Scan(bagID, bagID) --Tells the scan function to scan only the bags that change
    end
  end
end

function Liquid_Wealth:forceScan(command)
  if command == 1 then --Force Scan Bags
    Liquid_Wealth:Scan(0, 4);
  elseif command == 2 then --Force Scan Banks
    Liquid_Wealth:Scan(-1, -1);
    Liquid_Wealth:Scan(5, 11);
  else --Force Scan Using Remote Inv Addon.
  end
end

function Liquid_Wealth:Scan(startbag, endbag)
  local bagLink = ""
  local bagName = ""
  local bagTexturePath = ""
  --self:Print(startbag)
  --self:Print(endbag)
  if (startbag == endbag) then
    --self:Print("Start Bag == End Bag")
    if (GetContainerNumSlots(startbag) >= 1) and (startbag > 0) then --Check to see if player had bag equipped, and to skip bank and backpack
      local invID = ContainerIDToInventoryID(startbag);
      bagLink = GetInventoryItemLink("player", invID);
      local itemName, itemLink, _, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(bagLink)
      bagTexturePath = itemTexture
      bagName = itemName
    elseif startbag == -1 then --Bank
      bagLink = "Bank";
      bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
      bagName = "Bank"
    elseif startbag == 0 then --Backpack
      bagLink = "Backpack"
      bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
      bagName = "Backpack"
    else
      bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
      bagTexturePath = "NONE"
      bagName = "NONE"
    end
    Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[startbag] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, Liquid_Wealth:GetBagValueVender(startbag), Liquid_Wealth:GetBagValueAuction(startbag));
  else
    --self:Print("Start Bag Is Not == End Bag")
    for bagId = startbag, endbag do -- Add up the value of each bag's contents
      if (GetContainerNumSlots(bagId) >= 1) and (bagId > 0) then --Check to see if player had bag equipped, and to skip bank and backpack
        local invID = ContainerIDToInventoryID(bagId);
        bagLink = GetInventoryItemLink("player", invID);
        local itemName, itemLink, _, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(bagLink)
        bagTexturePath = itemTexture
        bagName = itemName
      elseif bagId == -1 then --Bank
        bagLink = "Bank";
        bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
        bagName = "Bank"
      elseif bagId == 0 then --Backpack
        bagLink = "Backpack";
        bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
        bagName = "Backpack"
      else
        bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
        bagTexturePath = "NONE"
        bagName = "NONE"
      end
      Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[bagId] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, Liquid_Wealth:GetBagValueVender(bagId), Liquid_Wealth:GetBagValueAuction(bagId));
    end
  end
  Liquid_Wealth.db.realm.toon[UnitName("player")].playergold = GetMoney();
  --Liquid_Wealth.db.realm.toon[UnitName("player")].lastChecked = date("%m/%d/%y %I:%M:%S %p");
  Liquid_Wealth.db.realm.toon[UnitName("player")].lastChecked = time()
end

function Liquid_Wealth:BANKFRAME_OPENED()
  if not InCombatLockdown() then
    varIsBankFrameOpen = true;
    Liquid_Wealth:Scan(-1, 11) --Loop though all the bags and bank bags
	Liquid_Wealth:ScanPT()
  end
end

function Liquid_Wealth:BANKFRAME_CLOSED()
  if not InCombatLockdown() then
    varIsBankFrameOpen = false;
  end
end

function Liquid_Wealth:CharTotal(toon)
  local VenderTotalRelam = 0;
  local AuctionTotalRelam = 0;
  for bagId = -1, 11 do -- Add up the value of each bag's contents
    local _, _, _, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(bagId, toon);
    VenderTotalRelam = VenderTotalRelam + VenderTotal;
    AuctionTotalRelam = AuctionTotalRelam + AuctionTotal;
  end
  -- VenderTotal=VenderTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
  -- AuctionTotal=AuctionTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
  return VenderTotalRelam, AuctionTotalRelam
end

function Liquid_Wealth:ConfigToolTip()
  tip = LibQTip:Acquire("Liquid_WealthTooltip", 5, "LEFT", "CENTER", "RIGHT")
  tip:Clear()
  tip:SetScale(1)
  tip:EnableMouse(true)
  if _G.TipTac and _G.TipTac.AddModifiedTip and Liquid_Wealth.db.profile.TipTacSkin then
    -- Pass true as second parameter because hooking OnHide causes C stack overflows
    _G.TipTac:AddModifiedTip(tip, true)
  end
  MetaDataVersion = GetAddOnMetadata("Liquid_Wealth", "Version")
  tip:SetCell(tip:AddHeader(""), 1, "Liquid-Wealth " .. MetaDataVersion, nil, "CENTER", 5)
  
  if Liquid_Wealth.db.profile.toolTipDebugEnabled then
		tooltipModeHeader = tip:AddHeader("");
		tip:SetCell(tooltipModeHeader, 2, "Player", nil, "CENTER");
		tip:SetCell(tooltipModeHeader, 3, "Guild", nil, "CENTER");
		tip:SetCell(tooltipModeHeader, 4, "PT Filter", nil, "CENTER");
  end
  
  
  if Liquid_Wealth.db.profile.toolTipDebugEnabled then
	  tip:AddLine("Col #1","Col #2","Col #3","Col #4","Col #5")
	  tip:SetColumnColor(1,255,0,0,.5)
	  tip:SetColumnColor(2,255,0,0,.5)
	  tip:SetColumnColor(3,255,0,0,.5)
	  tip:SetColumnColor(4,255,0,0,.5)
	  tip:SetColumnColor(5,255,0,0,.5)
  end
  if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
    Liquid_Wealth:showGuildBankToolTip()
  elseif (Liquid_Wealth.db.profile.displayMode == "PTFilter") then
	Liquid_Wealth:showFilterToolTip()
  else
    Liquid_Wealth:ConfigPlayerTooltip()
  end
end

function Liquid_Wealth:ConfigHintTip()
  tipLWHINT = LibQTip:Acquire("Liquid_WealthTooltipHint", 1, "LEFT")
  tipLWHINT:Clear()
  tipLWHINT:SetScale(1)
  tipLWHINT:EnableMouse(true)
  if _G.TipTac and _G.TipTac.AddModifiedTip and Liquid_Wealth.db.profile.TipTacSkin then
    -- Pass true as second parameter because hooking OnHide causes C stack overflows
    _G.TipTac:AddModifiedTip(tipLWHINT, true)
  end
  tipLWHINT:SetCell(tipLWHINT:AddHeader(""), 1, "Liquid-Wealth Hints", nil, "CENTER", 1)
  tipLWHINT:AddLine("|cffff8020Left Click |r on LDB plugin to change to and from Player & Guild Bank")
  tipLWHINT:AddLine("|cffff8020Shift Right Click |r on LDB plugin to view Custom Filter Mode")
  tipLWHINT:AddLine("|cffff8020Right Click |r on LDB plugin to open Configuration Window")
  _ ,englishClass = UnitClass("player")
  tipLWHINT:AddLine("|cffff8020Shift Left Click |r on LDB plugin to open To Force Scan of ".."|c"..Liquid_Wealth:ClassColor(englishClass)..UnitName("player").."|r".."'s Bags")
  tipLWHINT:SetPoint("CENTER", tip, "BOTTOM", 0, -48)
  tipLWHINT:Show()	
end

function Liquid_Wealth:ConfigPlayerTooltip()
  tip:SetCell(tip:AddHeader(""), 1, "Current Selected Player: " .. Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[varCurrentPlayer].unitID, 25) .. " " .. varCurrentPlayer, nil, "CENTER", 5)
  modeHeader = tip:AddHeader("")
  --tip:SetCell(modeHeader, 1,"Player", nil, "CENTER")
  if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
    tip:SetCell(modeHeader, 1, "Value Mode: Vender", nil, "CENTER", 5)
  else
    tip:SetCell(modeHeader, 1, "Value Mode: Auction - "..Liquid_Wealth.db.profile.selectedAuctionAddon, nil, "CENTER", 5)
  end
  tip:SetCellScript(modeHeader, 1, "OnMouseDown", function() Liquid_Wealth:ChangeViewModes() end);

  if Liquid_Wealth.db.profile.gdisplayMode == "Auction" then
    local lastScanTimeDate = Liquid_Wealth:GetAHLastTimeScaned()
    local LastAunctionDateTime = tip:AddLine("")
    if type(lastScanTimeDate)=="number" then
      tip:SetCell(LastAunctionDateTime, 1, "AH Full Scan: " .. date("%m/%d/%y %I:%M:%S %p", lastScanTimeDate), nil, "CENTER", 5)
      seconds = difftime(time(), lastScanTimeDate)
      if seconds >= 86400 then
        tip:SetCell(LastAunctionDateTime, 1, "|cFFFF0000AH Full Scan: " .. date("%m/%d/%y %I:%M:%S %p", lastScanTimeDate).. " - AH Data is Over 24h Old|r", nil, "CENTER", 5)
      else
        tip:SetCell(LastAunctionDateTime, 1, "AH Full Scan: " .. date("%m/%d/%y %I:%M:%S %p", lastScanTimeDate), nil, "CENTER", 5)
      end
  elseif type(lastScanTimeDate) == "string" then
      tip:SetCell(LastAunctionDateTime, 1, lastScanTimeDate, nil, "CENTER", 5)
  else
      tip:SetCell(LastAunctionDateTime, 1, "Unable To Get Time For Last AH Full Scan", nil, "CENTER", 5)
    end
  end

  header = tip:AddHeader("")
  tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t" .. " Player Bags", Liquid_Wealth.db.profile.noBagInfoTip and "Plus" or "Minus"))
  tip:SetCellScript(header, 1, "OnMouseDown", function()
    Liquid_Wealth.db.profile.noBagInfoTip = not Liquid_Wealth.db.profile.noBagInfoTip
    Liquid_Wealth:ToolTipUpDate()
  end)
  tip:SetCell(header, 4, "Value", nil,"CENTER",2)
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
  local playerDetail = tip:AddLine("")
  if (Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagId == nil) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked == 0) then
    tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Backpack") .. " Backpack", nil, "LEFT", 1)
    tip:SetCell(playerDetail, 2, "Sorry No Data Yet, Please Vist Bank Now", nil, "CENTER", 4)
  else
    if Liquid_Wealth.db.profile.noBagInfoTip then
      local VenderTotalToon = 0;
      local AuctionTotalToon = 0;
      for bagId = 0, 4 do -- Add up the value of each bag's contents
        _, _, _, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(bagId, varCurrentPlayer)
        VenderTotalToon = VenderTotalToon + VenderTotal
        AuctionTotalToon = AuctionTotalToon + AuctionTotal
      end

      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Backpack") .. " Backpack", nil, "LEFT", 2)
      if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotalToon, true), nil, "RIGHT", 2)
      else
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotalToon, true), nil, "RIGHT", 2)
      end
    else
      local BagItemLink, BagIconPath, BagName, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(0, varCurrentPlayer)
      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Backpack") .. " Backpack", nil, "LEFT", 2)
      if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
      else
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
      end

      for bagId = 1, 4 do -- Add up the value of each bag's contents
        local BagItemLink, BagIconPath, BagName, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(bagId, varCurrentPlayer)
        local playerDetail = tip:AddLine("")
        if BagItemLink == "NOSCAN" then
          tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("NONE"), nil, "LEFT", 2)
          tip:SetCell(playerDetail, 3, "Sorry No Data Yet, Please Vist Bank Now", nil, "CENTER", 4)
        elseif (BagItemLink == "NONE") then
          tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons(BagItemLink) .. " Not Equipped", nil, "LEFT", 2)
          if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
          else
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
          end
        else
          tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons(BagItemLink, BagIconPath) .. " " .. BagName, nil, "LEFT", 1)
          if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
          else
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
          end
        end
      end
    end
  end
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
  header = tip:AddHeader("")
  tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t" .. " Bank Bags", Liquid_Wealth.db.profile.noBankInfoTip and "Plus" or "Minus"))
  tip:SetCellScript(header, 1, "OnMouseDown", function()
    Liquid_Wealth.db.profile.noBankInfoTip = not Liquid_Wealth.db.profile.noBankInfoTip
    Liquid_Wealth:ToolTipUpDate()
  end)
  tip:SetCell(header, 4, "Value", nil,"CENTER",2)
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
  local playerDetail = tip:AddLine("")
  if ((not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked == 0)) or (not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[-1]) then
    tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Bank") .. " Bank", nil, "LEFT", 2)
    tip:SetCell(playerDetail, 3, "Sorry No Data Yet, Please Scan Now", nil, "CENTER", 3)
  else
    if Liquid_Wealth.db.profile.noBankInfoTip then
      local VenderTotal = 0;
      local AuctionTotal = 0;
      for bagId = 5, 11 do -- Add up the value of each bag's contents
        _, _, _, Vender, Auction = Liquid_Wealth:ConvItemDataFromDB(bagId, varCurrentPlayer)
        VenderTotal = VenderTotal + Vender
        AuctionTotal = AuctionTotal + Auction
      end
      _, _, _, Vender, Auction = Liquid_Wealth:ConvItemDataFromDB(-1, varCurrentPlayer)
      VenderTotal = VenderTotal + Vender
      AuctionTotal = AuctionTotal + Auction
      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Bank") .. " Bank", nil, "LEFT", 2)
      if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
      else
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
      end

    else
      local BagItemLink, BagIconPath, BagName, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(-1, varCurrentPlayer)
      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons("Bank") .. " Bank", nil, "LEFT", 2)
      if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
      else
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
      end

      for bagId = 5, 11 do -- Add up the value of each bag's contents
        local BagItemLink, BagIconPath, BagName, VenderTotal, AuctionTotal = Liquid_Wealth:ConvItemDataFromDB(bagId, varCurrentPlayer)
        local playerDetail = tip:AddLine("")
        if (BagItemLink == "NONE") then
          tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons(BagItemLink) .. " Not Equipped", nil, "LEFT", 2)
          if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
          else
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
          end
        else
          tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildBagIcons(BagItemLink, BagIconPath) .. " " .. BagName, nil, "LEFT", 2)
          if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(VenderTotal, true), nil, "RIGHT", 2)
          else
            tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(AuctionTotal, true), nil, "RIGHT", 2)
          end
        end
      end
    end
  end
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
  local Header = tip:AddLine("");
  tip:SetCell(Header, 1, "|cffeda55fCharacter|r", nil, "LEFT", 2)
  tip:SetCell(Header, 3, "|cffeda55fScan Date|r", nil, "CENTER", 1)
  if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
    tip:SetCell(Header, 4, "|cffeda55fTotal [Vender]|r", nil, "RIGHT", 2)
  else
    tip:SetCell(Header, 4, "|cffeda55fTotal [Acution]|r", nil, "RIGHT", 2)
  end

  --Sorted List Goes Here
  Liquid_Wealth:returnSortedCharListed(tip)
end

function Liquid_Wealth:returnSortedCharListed(tip)
  local relamTotalVender = 0;
  local relamTotalAuct = 0;
  --Loop though all the toons stored in the database
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
  for chars in pairs(self.db.realm.toon) do
    local playerDetail = tip:AddLine("");
    --If there is no data for the current login toon display "Scan Now Message" and Build Sex & Race Icons
    if (Liquid_Wealth.db.realm.toon[chars].bagId == nil) and (Liquid_Wealth.db.realm.toon[chars].lastChecked == 0) then
      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[chars].unitID) .. " " .. chars, nil, "LEFT", 2);
      tip:SetCell(playerDetail, 3, "Sorry No Data Yet, Please Scan Now", nil, "CENTER", 3);
    else
      --Set the linescript to change the currently viewed toon to the selected. Build the Race & Sex Icons, and then add up the current total for the toon.
      local vend, auct = Liquid_Wealth:CharTotal(chars);
      tip:SetLineScript(playerDetail, "OnMouseDown", function() Liquid_Wealth:ViewPlayer(chars) end);
      tip:SetCell(playerDetail, 1, Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[chars].unitID,20) .. " |c" .. Liquid_Wealth:ClassColor(Liquid_Wealth.db.realm.toon[chars].unitID) .. chars .. "|r", nil, "LEFT", 2);
      tip:SetCell(playerDetail, 3, date("%m/%d/%y %I:%M:%S %p", Liquid_Wealth.db.realm.toon[chars].lastChecked), nil, "CENTER", 1);
      if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(vend, true), nil, "RIGHT", 2);
      else
        tip:SetCell(playerDetail, 4, Liquid_Wealth:copperToText(auct, true), nil, "RIGHT", 2);
      end
      relamTotalVender = relamTotalVender + vend;
      relamTotalAuct = relamTotalAuct + auct;
    end
    --Adds a nice yellow line to who is the currently selected player in the tooltip
    if chars == varCurrentPlayer then
      tip:SetLineColor(playerDetail, 255, 255)
    end
  end
  --Calculate the total for the current relam
  local relamDetail = tip:AddLine("");
  tip:SetCell(relamDetail, 1, "Total Amount On Relam:", nil, "LEFT", 1);
  if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
    tip:SetCell(relamDetail, 4, Liquid_Wealth:copperToText(relamTotalVender, true), nil, "RIGHT", 2);
  else
    tip:SetCell(relamDetail, 4, Liquid_Wealth:copperToText(relamTotalAuct, true), nil, "RIGHT", 2);
  end
  tip:AddLine("")
  tip:AddSeparator(2)
  tip:AddLine("")
end

function Liquid_Wealth:ToolTipUpDate()
  Liquid_Wealth:ConfigToolTip();
  tip:Show();
end

function Liquid_Wealth:ChangeViewModes()
  if Liquid_Wealth.db.profile.gdisplayMode == "Vender" then
    Liquid_Wealth.db.profile.gdisplayMode = "Auction"
  else
    Liquid_Wealth.db.profile.gdisplayMode = "Vender"
  end
  Liquid_Wealth:ConfigToolTip()
  tip:Show();
end

function Liquid_Wealth:ViewPlayer(Toon)
  varCurrentPlayer = Toon;
  Liquid_Wealth:ToolTipUpDate()
end

function HideTooltipLW()
  if MouseIsOver(tip) then return end
  tip:SetScript('OnLeave', nil)
  if Liquid_Wealth.db.profile.displayHints then
    HideToolTipHint() -- This should hide the hint tooltip when we move our mouse away from the LW tooltip.
  end
  tooltipIsShown = false
  LibQTip:Release(tip)
  tip = nil
end

function HideToolTipHint()
  if MouseIsOver(tip) then return end
  tipLWHINT:SetScript('OnLeave', nil)
  LibQTip:Release(tipLWHINT)
  tipLWHINT = nil
end

function ldb_obj.OnLeave(self)
  if MouseIsOver(tip) then
    tip:SetScript('OnLeave', HideTooltipLW)
  else
    HideTooltipLW()
  end
end

function ldb_obj.OnEnter(self) --When you hover over ldb plugin show LW Tooltip
  Liquid_Wealth:ConfigToolTip()
  if Liquid_Wealth.db.profile.displayHints then
    Liquid_Wealth:ConfigHintTip()
  end
  tip:SmartAnchorTo(self)
  tip:Show()
end

function ldb_obj.OnClick(self, button) --When Clicking on the ldb plugin do some functions
	if button == "LeftButton" and IsShiftKeyDown() then
		print("Force Scanning of |c"..Liquid_Wealth:ClassColor(englishClass)..UnitName("player").."|r".."'s Bags is now in progress")
		Liquid_Wealth:forceScan(1)
		Liquid_Wealth:ConfigToolTip()
	elseif button == "RightButton" and IsShiftKeyDown() then
		Liquid_Wealth.db.profile.displayMode = "PTFilter"
		ldbTitleCompatibility("Custom Filter")
		Liquid_Wealth:ConfigToolTip()
	elseif button == "RightButton" and IsControlKeyDown() then
		Liquid_Wealth:copperToText(GetMoney())
	elseif button == "RightButton" then
		InterfaceOptionsFrame_OpenToCategory("LiquidWealth");
	elseif button == "LeftButton" then
		if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
			Liquid_Wealth.db.profile.displayMode = "Player";
			ldbTitleCompatibility("Player")
		else
			Liquid_Wealth.db.profile.displayMode = "GuildBank";
			ldbTitleCompatibility("Guild Bank")
		end
    Liquid_Wealth:ConfigToolTip()
    if Liquid_Wealth.db.profile.displayHints then
		Liquid_Wealth:ConfigHintTip()
    end
    tip:SmartAnchorTo(self)
    tip:Show()
  end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

function Liquid_Wealth:copperToText(value)
	local COLOR_COPPER = "ffeda55f"
	local COLOR_SILVER = "ffc7c7cf"
	local COLOR_GOLD = "ffffd700"
	local gold = floor(math.abs(value) / 10000)
	local silver = mod(floor(math.abs(value) / 100), 100)
	local copper = mod(floor(math.abs(value)), 100)
	return (comma_value(gold) .. "|c" .. COLOR_GOLD .. "g|r ".. comma_value(silver) .. "|c" .. COLOR_SILVER .. "s|r ".. comma_value(copper) .. "|c" .. COLOR_COPPER .. "c|r")
end
